SystemOrganization addCategory: #'Mustache-Seaside-Examples'!

WAExampleComponent subclass: #MustacheCounter
	instanceVariableNames: 'count mustacheInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Examples'!

!MustacheCounter class methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:51'!
description
	^ 'A very simple Seaside/Mustache application'! !

!MustacheCounter class methodsFor: 'examples' stamp: 'JesusMari 12/3/2012 11:08'!
example
	^ self new! !

!MustacheCounter class methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:50'!
handlerName
	^ 'examples/mustacheCounter'! !

!MustacheCounter class methodsFor: 'initialization' stamp: 'JesusMari 12/3/2012 11:08'!
initialize
	WAAdmin register: self asApplicationAt: self handlerName! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
count
	^ count! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
count: anInteger
	count := anInteger! !

!MustacheCounter methodsFor: 'actions' stamp: 'JesusMari 12/3/2012 11:08'!
decrease
	count := count - 1! !

!MustacheCounter methodsFor: 'actions' stamp: 'JesusMari 12/3/2012 11:08'!
increase
	count := count + 1! !

!MustacheCounter methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 15:37'!
initialize
	super initialize.
	self count: 0! !

!MustacheCounter methodsFor: 'rendering' stamp: 'JesusMari 2/18/2013 13:38'!
renderContentOn: html
"Server side rendered mustache"
	html mustache 
			basePath:'D:\smalltalk\SCouchViewServer\templates\';
			template:'counter';
			view: (JsonObject fromAssociations: {
						'counter'-> self count.
						'seasideContent'->[:stack : htmlCanvas|
							htmlCanvas heading: count.
							htmlCanvas anchor
								callback: [ self increase ];
								with: '++'.
							htmlCanvas space.
							htmlCanvas anchor
								callback: [ self decrease ];
								with: '--'
							]
					}).
	! !

!MustacheCounter methodsFor: 'accessing' stamp: 'JesusMari 12/3/2012 11:08'!
states
	^ Array with: self! !

WAExampleComponent subclass: #MustacheCounter2
	instanceVariableNames: 'count mustacheInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Examples'!

!MustacheCounter2 class methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
description
	^ 'A very simple Seaside/Mustache application'! !

!MustacheCounter2 class methodsFor: 'examples' stamp: 'JesusMari 12/5/2012 16:07'!
example
	^ self new! !

!MustacheCounter2 class methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:20'!
handlerName
	^ 'examples/mustacheCounter2'! !

!MustacheCounter2 class methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 16:07'!
initialize
	WAAdmin register: self asApplicationAt: self handlerName! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
count
	^ count! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
count: anInteger
	count := anInteger! !

!MustacheCounter2 methodsFor: 'actions' stamp: 'JesusMari 12/5/2012 16:07'!
decrease
	count := count - 1! !

!MustacheCounter2 methodsFor: 'actions' stamp: 'JesusMari 12/5/2012 16:07'!
increase
	count := count + 1! !

!MustacheCounter2 methodsFor: 'initialization' stamp: 'JesusMari 12/5/2012 16:07'!
initialize
	super initialize.
	self count: 0! !

!MustacheCounter2 methodsFor: 'rendering' stamp: 'JesusMari 12/15/2012 17:22'!
renderContentOn: html

	html mustache 
			template:MustacheCounterTemplate;
			view: (JsonObject fromAssociations: {
						'counter'->self count.
						'instance'->self  .
					}).
	! !

!MustacheCounter2 methodsFor: 'accessing' stamp: 'JesusMari 12/5/2012 16:07'!
states
	^ Array with: self! !

MustacheTemplate subclass: #MustacheCounterTemplate
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Examples'!

!MustacheCounterTemplate methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/20/2012 05:22'!
render
^'<h1>Mustache Counter:{{counter}}</h1>

<p>Hello "Seaside code" passed through a View to Mustache </p>

{{[
	html paragraph:''Hello again from seaside inside a square bracket''.
	html paragraph:aView asString.
	html anchor
			callback:[aView instance increase];
			with: ''++''.
			
	html space.
	html anchor
			callback:[aView instance decrease];
			with: ''--''.							
]}}

{{>Partial3}}'! !

MustacheCounterTemplate subclass: #Partial3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Seaside-Examples'!

!Partial3 methodsFor: 'as yet unclassified' stamp: 'JesusMari 12/9/2012 13:06'!
render

^'{{[ 
		html heading: (aView at:''counter'').
	]}}'! !
MustacheCounter2 initialize!
MustacheCounter initialize!
